<?php

require_once '../bootstrap/bootstrap.php';

$instanceManager = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance();

/** @var Doctrine\ORM\EntityManager $entityManager */
$entityManager = $instanceManager->getService('entityManager');
/** @var \Teknisa\Libs\Util\NewCode $newCode */
$newCode = $instanceManager->getService('newCodeSC');

$scriptsPath = __DIR__ . '/../vendor/teknisa/entities/scripts/reference';
//$scriptsPath = __DIR__ . '/../vendor/zeedhi/devops_entities/migrations';
$currentUser = '000000002925'; $nrorg = 20; $repositorioId = 1;
$filesToExec = [];

$files = array_diff(scandir($scriptsPath), array('..', '.'));
usort($files, function($currentFile, $nextFile) {
    if(strpos($currentFile, 'down') === false) {
        $delimiter         = strpos($currentFile, '_') ? '_' : '.';
        $currentFileNumber = intval(explode($delimiter, $currentFile)[0]);
        $nextFileNumber    = intval(explode($delimiter, $nextFile)[0]);
        return $currentFileNumber < $nextFileNumber ? -1 : 1;
    } else {
        return 0;
    }
});

foreach($files as $file) {
    if(strpos($file, 'down') === false) {
        $delimiter  = strpos($file, '_') ? '_' : '.';
        $fileNumber = explode($delimiter, $file)[0];

        if (is_numeric($fileNumber) && (empty($filesToExec) || in_array($fileNumber, $filesToExec))) {
            echo "Criando arquivo $fileNumber ... \n";
            $fileNumber  = intval($fileNumber);
            $script      = utf8_encode(file_get_contents($scriptsPath . DIRECTORY_SEPARATOR . $file));

            $date = new \DateTime();
            $e = new \Teknisa\Model\Teknisa\Entities\MtDesignEstrutura();
            $e->setId($newCode->getCodeByTableName("MT_DESIGN_ESTRUTURA", $nrorg, 1, 10, true));
            $e->setNrorg($nrorg);
            $e->setNrorginclusao($nrorg);
            $e->setDtinclusao($date);
            $e->setCdoperinclusao($currentUser);

            $e->setScript($script);
            $e->setDsdesEstrutura($file);
            $e->setNrScript($fileNumber);
            $e->setidResultScript('ES');
            $e->setRepositorioId($repositorioId);

            $e->setIdativo('S');
            $e->setNrorgultatu($nrorg);
            $e->setDtultatu($date);
            $e->setCdoperultatu($currentUser);

            $entityManager->persist($e);
            $entityManager->flush();
        }
    }
}

$strNewCode = 'MT_DESIGN_ESTRUTURA_NRSCRIPT_' . $repositorioId;
$newCode->getCodeByTableName($strNewCode, $nrorg, 1, 10, true);