<?php
namespace Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource;
use Util\Instance\ServiceInstance;

class View {
    
    public function findView(DTO\Request\Filter $request, DTO\Response $response)
    {
        $page = $request->getFilterCriteria()->getPage();
        $pageSize = $request->getFilterCriteria()->getPageSize();
        $filters = $request->getFilterCriteria()->getConditions();
        $view = ServiceInstance::getView()->findView($filters, $page, $pageSize);
        $response->addDataSet(new DataSource\DataSet('view', $view));
    }

    public function findViewColumns(DTO\Request\Filter $request, DTO\Response $response)
    {
        $page = $request->getFilterCriteria()->getPage();
        $pageSize = $request->getFilterCriteria()->getPageSize();
        $filters = $request->getFilterCriteria()->getConditions();
        $viewColumns = ServiceInstance::getView()->findViewColumns($filters, $page, $pageSize);
        $response->addDataSet(new DataSource\DataSet('viewColumns', $viewColumns));
    }

}

